searchNodes=[{"ref":"ResuelveAuth.AuthPlug.html","title":"ResuelveAuth.AuthPlug","type":"module","doc":"Plug para autenticacion mediante verificacion de firma de tokens. Valores por defecto: limit_time: 1 semana en horas secret: llave para generar el token vacia handler: Módulo de ejemplo para responder errores Ejemplo: # En el archivo router.ex defmodule MyApi.Router do # Se usan 10 horas como vigencia del token y # se toma el comportamiento por defecto del handler. @options [secret: &quot;mi-llave-secreta&quot;, limit_time: 10] use MyApi, :router pipeline :auth do plug ResuelveAuth.AuthPlug, @options end scope &quot;/v1&quot;, MyApi do pipe_through([:auth]) .. post(&quot;/users/&quot;, UserController, :create) end end"},{"ref":"ResuelveAuth.Helpers.TokenHelper.html","title":"ResuelveAuth.Helpers.TokenHelper","type":"module","doc":"Modulo para la generacion y verificacion de tokens JWT"},{"ref":"ResuelveAuth.Helpers.TokenHelper.html#create_token/2","title":"ResuelveAuth.Helpers.TokenHelper.create_token/2","type":"function","doc":"Genera un token usando un mapa. Retorna un token con el siguiente formato JSON_EN_BASE64_SEGURO_PARA_URLS.FIRMA_HMAC_SHA_256_EN_BASE_16 Examples iex&gt; alias ResuelveAuth.TokenData iex&gt; timestamp = 1572656155135 iex&gt; data = %TokenData{ meta: nil, role: &quot;service&quot;, service: &quot;my-api&quot;, session: nil, timestamp: timestamp } iex&gt; options = [secret: &quot;secret&quot;, limit_time: 4] iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; token = TokenHelper.create_token(data, options) &quot;eyJ0aW1lc3RhbXAiOjE1NzI2NTYxNTUxMzUsInNlc3Npb24iOm51bGwsInNlcnZpY2UiOiJteS1hcGkiLCJyb2xlIjoic2VydmljZSIsIm1ldGEiOm51bGx9.1E1FA5A03B62DB5E0E5C5627D578E4ABBD1E83EFBFF72907428D0C95DC491394&quot; iex&gt; String.length(token) 185"},{"ref":"ResuelveAuth.Helpers.TokenHelper.html#extract/1","title":"ResuelveAuth.Helpers.TokenHelper.extract/1","type":"function","doc":"Extrae la fecha de un mapa en el formato {:ok, %{}} esperando que sea un formato de unix y convertirlo a fecha. Ejemplos: iex&gt; timestamp = 1583797948623 iex&gt; data = %{&quot;timestamp&quot; =&gt; timestamp, &quot;otra_llave&quot; =&gt; &quot;algo&quot;} iex&gt; parameter = {:ok, data} iex&gt; {:ok, data} = ResuelveAuth.Helpers.TokenHelper.extract(parameter) iex&gt; Map.keys(data) [&quot;otra_llave&quot;, &quot;time&quot;, &quot;timestamp&quot;]"},{"ref":"ResuelveAuth.Helpers.TokenHelper.html#is_expired/2","title":"ResuelveAuth.Helpers.TokenHelper.is_expired/2","type":"function","doc":"Identifica si el tiempo resultante (primer parámetro) es menor o igual al tiempo límite (segundo parámetro). Ejemplo: iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(4, 5) false iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(4, 4) false iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(5, 4) true"},{"ref":"ResuelveAuth.Helpers.TokenHelper.html#verify_token/2","title":"ResuelveAuth.Helpers.TokenHelper.verify_token/2","type":"function","doc":"Verifica si el token es válido y devuelve una mapa con los datos del token. Ejemplos: iex&gt; alias ResuelveAuth.TokenData iex&gt; timestamp = DateTime.to_unix(DateTime.utc_now(), :millisecond) iex&gt; data = %TokenData{ meta: nil, role: &quot;service&quot;, service: &quot;my-api&quot;, session: nil, timestamp: timestamp } iex&gt; options = [secret: &quot;secret&quot;, limit_time: 4] iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; token = TokenHelper.create_token(data, options) iex&gt; {:ok, result} = TokenHelper.verify_token(token, options) iex&gt; result[&quot;timestamp&quot;] == data.timestamp true iex&gt; result[&quot;service&quot;] == data.service true"},{"ref":"ResuelveAuth.Sample.AuthHandler.html","title":"ResuelveAuth.Sample.AuthHandler","type":"module","doc":"Ejemplo de una implementación de un handler para la autenticación."},{"ref":"ResuelveAuth.Sample.AuthHandler.html#errors/2","title":"ResuelveAuth.Sample.AuthHandler.errors/2","type":"function","doc":"Maneja los errores que puede responder el plug"},{"ref":"ResuelveAuth.Sample.AuthHandler.html#reason/1","title":"ResuelveAuth.Sample.AuthHandler.reason/1","type":"function","doc":""},{"ref":"ResuelveAuth.TokenData.html","title":"ResuelveAuth.TokenData","type":"module","doc":"Estructura que define los elementos de un token"},{"ref":"ResuelveAuth.TokenData.html#cast/2","title":"ResuelveAuth.TokenData.cast/2","type":"function","doc":"Convierte el token a datos válidos o regresa un error."},{"ref":"ResuelveAuth.Utils.Calendar.html","title":"ResuelveAuth.Utils.Calendar","type":"module","doc":"Encapsula las funciones relacionadas con la fecha. Si se requiere usar alguna biblioteca de tiempo, aquí debe agregarse la funcionalidad deseada. En el proyecto solo se deben encontrar llamadas al módulo de Calendar para facilitar el mantenimiento del código."},{"ref":"ResuelveAuth.Utils.Calendar.html#diff/2","title":"ResuelveAuth.Utils.Calendar.diff/2","type":"function","doc":"Regresa la diferencia en horas de dos fechas enviadas como parámetros en formato unix. Ejemplo: iex&gt; {ayer, ahora} = {1577646287000, 1577733231563} iex&gt; {:ok, first} = DateTime.from_unix(ayer, :millisecond) iex&gt; {:ok, second} = DateTime.from_unix(ahora, :millisecond) iex&gt; ResuelveAuth.Utils.Calendar.diff(first, second) - 24 iex&gt; {ayer, ahora} = {1577646287000, 1577733231563} iex&gt; {:ok, first} = DateTime.from_unix(ayer, :millisecond) iex&gt; {:ok, second} = DateTime.from_unix(ahora, :millisecond) iex&gt; ResuelveAuth.Utils.Calendar.diff(second, first) 24"},{"ref":"ResuelveAuth.Utils.Calendar.html#from_unix/1","title":"ResuelveAuth.Utils.Calendar.from_unix/1","type":"function","doc":"Convierte un valor de unix_time a una estructura DateTime. iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; {:ok, %DateTime{} = date} = Calendar.from_unix(1572617244) iex&gt; DateTime.to_unix(date) 1572617 iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.from_unix(1724.0) {:error, :invalid_unix_time} iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.from_unix(&quot;algo&quot;) {:error, :invalid_unix_time}"},{"ref":"ResuelveAuth.Utils.Calendar.html#is_past?/1","title":"ResuelveAuth.Utils.Calendar.is_past?/1","type":"function","doc":"Identifica si la fecha enviada como Unix time es pasada. En caso de mandar un valor que no sea entero, regresa true por defecto. Ejemplos iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; unix_time = 1572617244 iex&gt; Calendar.is_past?(unix_time) true iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; unix_time = 4128685709000 iex&gt; Calendar.is_past?(unix_time) false iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.is_past?(&quot;2100-02-29T12:30:30+00:00&quot;) true"},{"ref":"ResuelveAuth.Utils.Calendar.html#unix_now/0","title":"ResuelveAuth.Utils.Calendar.unix_now/0","type":"function","doc":"Regresa la fecha actual en unix time. Ejemplo: &gt; ResuelveAuth.Utils.Calendar.unix_now() 1577733231563"},{"ref":"ResuelveAuth.Utils.Secret.html","title":"ResuelveAuth.Utils.Secret","type":"module","doc":"Contiene lógica de codificación, decodificación, cifrado y descifrado."},{"ref":"ResuelveAuth.Utils.Secret.html#cypher/1","title":"ResuelveAuth.Utils.Secret.cypher/1","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#cypher/2","title":"ResuelveAuth.Utils.Secret.cypher/2","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#cypher/3","title":"ResuelveAuth.Utils.Secret.cypher/3","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#decode/1","title":"ResuelveAuth.Utils.Secret.decode/1","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#decode64/1","title":"ResuelveAuth.Utils.Secret.decode64/1","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#encode/1","title":"ResuelveAuth.Utils.Secret.encode/1","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#encode64/1","title":"ResuelveAuth.Utils.Secret.encode64/1","type":"function","doc":""},{"ref":"ResuelveAuth.Utils.Secret.html#equivalent?/2","title":"ResuelveAuth.Utils.Secret.equivalent?/2","type":"function","doc":"Identifica si la tupla de la cadena firmada es válida de acuerdo al token enviado. Ejemplo: iex&gt; alias ResuelveAuth.Utils.Secret iex&gt; data = {:error, &quot;mensaje de error&quot;} iex&gt; Secret.equivalent?(data, &quot;data&quot;) {:error, &quot;mensaje de error&quot;} iex&gt; alias ResuelveAuth.Utils.Secret iex&gt; data = %{valid: &quot;datos&quot;} iex&gt; Secret.equivalent?(data, &quot;datos&quot;) true"},{"ref":"ResuelveAuth.Utils.Secret.html#sign/2","title":"ResuelveAuth.Utils.Secret.sign/2","type":"function","doc":"Firma la información con una semilla (secret) pasando primero por un proceso de códificación."},{"ref":"readme.html","title":"ResuelveAuth","type":"extras","doc":"ResuelveAuth Plug para validar peticiones firmadas"},{"ref":"readme.html#contenido","title":"ResuelveAuth - CONTENIDO","type":"extras","doc":"Agregar al proyecto Configuración Generación del secret Crear token y validarlo Manejo de errores Errores"},{"ref":"readme.html#agregar-al-proyecto","title":"ResuelveAuth - Agregar al proyecto","type":"extras","doc":"def deps do [{:resuelve_auth, &quot;~&gt; v1.3&quot;}] end Agregar el Plug a un pipeline, siguiendo las guías para crear bibliotecas en Elixir, se configuran las opciones y se puede enviar al plug. pipeline :api_auth do ... options = [ secret: &quot;secret&quot;, limit_time: 4, handler: MyApp.AuthHandler ] plug ResuelveAuth.AuthPlug, options end"},{"ref":"readme.html#configuración","title":"ResuelveAuth - Configuración","type":"extras","doc":"En tu proyeto puedes definir el nivel de logs que deseas manejar: # config/dev.exs config :logger, :console, format: &quot;[$level] $message\\n&quot; # config/prod.exs config :logger, level: :info"},{"ref":"readme.html#creación-del-secret","title":"ResuelveAuth - Creación del secret","type":"extras","doc":"Si se tiene un proyecto con phoenix se puede generar una llave con el comando: $&gt; mix phx.gen.secret 32 TICxDq3wquPi49UuMfA4PjnWpz1PqnB1 $&gt; mix phx.gen.secret 64 b9sq3yGrwWKXxpNfx3+a8hEaRa3S5QWMiRg+gPpbzc54ZpjVaqDYD3DRbPuYx621 Otra forma de generar un secret es: $&gt; date +%s | sha256sum | base64 | head -c 32 ; echo MGYwM2M1Njk1MGIxYjcyOGY3OTc0ZDk0 $&gt; date +%s | sha256sum | base64 | head -c 64 ; echo ZGZhMzZhOWQyZTViOWQxNWIyY2NlMGExMDVhMzQ1ZGNkODA1YWUxNmRmMWRjMGZi Con openssl: $&gt; openssl rand -base64 32 //ZE5siYI04Bp/2JtFq3uJOpS4XXChADe8b9RHenzFY= $&gt; openssl rand -base64 64 qlTw8sjiavcPAKIHJbO/zOUqLCS99zmyerjnoRc6FumLIc/Q9K9TjitS4JmTFh5r 3ULjJAMfkouTR1OUV4LZ4Q=="},{"ref":"readme.html#crear-token-y-validarlo","title":"ResuelveAuth - Crear token y validarlo","type":"extras","doc":"iex&gt; alias ResuelveAuth.TokenData iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; token_data = %TokenData{ service: service, role: &quot;service&quot;, meta: &quot;metadata&quot;, timestamp: DateTime.to_unix(DateTime.utc_now(), :millisecond) } iex&gt; options = [secret: &quot;super-secret-key&quot;, limit_time: 4] iex&gt; token = TokenHelper.create_token(token_data, options[:secret]) iex&gt; {:ok, %{&quot;meta&quot; =&gt; meta}} = TokenHelper.verify_token(token, options)"},{"ref":"readme.html#errores","title":"ResuelveAuth - Errores","type":"extras","doc":"Los siguientes son los errores que regresa el plug: ErrorDescripción expired:El token ha expirado unauthorized:No autorizado wrong_format:Formato de token incorrecto"},{"ref":"readme.html#manejador-de-errores","title":"ResuelveAuth - Manejador de errores","type":"extras","doc":"Si el formato de respuesta no es el que se desea, se puede configurar la respuesta asociando un módulo como manejador de errores. defmodule Module.Handler do def errors(conn, reason) do # lógica para responde el error end end iex&gt; options = [secret: &quot;super-secret-key&quot;, limit_time: 4, handler: Module.Handler] iex&gt; token = TokenHelper.verify_token(token, options) Basta con que exista una función llamada errors/2 en el handler para que se pueda responder apropiadamente el error, los parámetros son la conección y un objeto que contenga el mensaje de error. La verificación de token verify_token realmente no se llama directamente, esta se invoca internamente en el plug cuando se manda a llamar la función ResuelveAuth.Plugs.TokenAuth.call/2. Para saber más se puede consultar el módulo ResuelveAuth.Sample.AuthHandler."},{"ref":"readme.html#todo","title":"ResuelveAuth - TODO","type":"extras","doc":"[x] Añadir proceso de integración continua [x] Agregar herramientas para medir la covertura de código [x] Automatizar la generación de documentación [x] Agregar el CHANGELOG del proyeto [x] Documentar el proyecto"}]